---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by Ryann1908.
--- DateTime: 09/21/2020 14:16
---

--- Player Class
himeka_player=Class(player_class) --- Defines that this file belongs to a player, aka a player class

--- Initialize
function himeka_player:init() --- Initializing the player
    LoadTexture('himeka_player','THlib\\player\\himeka\\himeka.png') --- Loads the whole spritesheet
    LoadImageFromFile('himeka_bom','THlib\\player\\himeka\\himeka_bom.png',true,0,0,false,0) --- Loads the fog graphic for himeka's clouds
    LoadImageGroup('himeka_player','himeka_player',0,0,32,48,8,3,0.5,0.5) --- Loads the himeka player sprite
    LoadImage('himeka_support','himeka_player',0,178,24,24) --- Loads himeka's options/support graphic
	LoadImage('himeka_mainshot','himeka_player',0,144,35,16)
	LoadImage('himeka_greenpellet','himeka_player',0,160,60,18)
	LoadImage('himeka_greenpellet2','himeka_player',0,160,60,18)
	
    player_class.init(self)
    self.name='himeka' --- Gives the player name
    self.hspeed=4.5 --- The player's speed
    self.imgs={} --- Table for the player sprites
    self.A=0.5 self.B=0.5 --- The player's hitbox
    for i=1,24 do self.imgs[i]='himeka_player'..i end --- The player's sprite animation
    self.slist=
    {
        {nil,nil,nil,nil},
        {{0,30,0,15}     ,           nil,         nil,           nil},
        {{-25,0,-13,0},{25,0,13,0}    ,         nil,           nil},
        {{0,30,0,15},{-30,0,-15,0},{30,0,15,0},           nil},
        {{-20,25,-10,18},{20,25,10,18},{-55,0,-25,0},{55,0,25,0}},
        {{-20,25,-10,18},{20,25,10,18},{-55,0,-25,0},{55,0,25,0}},
    } --- The options positioning
    self.anglelist=
    {
        {90,90,90,90},
        {90,90,90,90},
        {100,80,90,90},
        {100,90,80,90},
        {110,100,80,70},
    } --- Angle list for the shots
end

--- Shoot
function himeka_player:shoot()
    PlaySound('plst00',0.3,self.x/1024) --- Plays the shot sound
    self.nextshoot=4 --- Defines the interval for the player to shoot again
    New(himeka_dark_shot,'himeka_mainshot',self.x-10,self.y+5,1.7) --- Creates himeka's main shot in the left side
    New(himeka_dark_shot,'himeka_mainshot',self.x+10,self.y+5,1.7) --- Creates himeka's main shot in the right side
    local num=int(lstg.var.power/100)+1
	if self.timer % 8 < 5 then
		for i=1,4 do --- Does an operation 4 times
			if self.sp[i] and self.sp[i][3]>0.5 then --- Self support shenanigans; this is to calculate the shots that will be fired in the options
				if self.slow == 0 then
					New(himeka_subshot_blue,'himeka_greenpellet',self.supportx+self.sp[i][1],self.supporty+self.sp[i][2],0.55,75) --- Creates the blue shot
					New(himeka_subshot_blue,'himeka_greenpellet',self.supportx+self.sp[i][1],self.supporty+self.sp[i][2],0.55,85)
					New(himeka_subshot_blue,'himeka_greenpellet',self.supportx+self.sp[i][1],self.supporty+self.sp[i][2],0.55,95)
					New(himeka_subshot_blue,'himeka_greenpellet',self.supportx+self.sp[i][1],self.supporty+self.sp[i][2],0.55,105)
				else
					New(himeka_subshot_blue,'himeka_greenpellet',self.supportx+self.sp[i][1],self.supporty+self.sp[i][2],0.73,85) --- Creates the blue shot
					New(himeka_subshot_blue,'himeka_greenpellet',self.supportx+self.sp[i][1],self.supporty+self.sp[i][2],0.73,90)
					New(himeka_subshot_blue,'himeka_greenpellet',self.supportx+self.sp[i][1],self.supporty+self.sp[i][2],0.73,95)
				end
			end
		end
	end
end

--- Spell/Bomb
function himeka_player:spell()
    self.nextspell=377 --- Time until you can bomb again
    self.protect=60*8 --- Invulnerability time
    self.collect_line=self.collect_line-300 --- Lowers the PoC line
    New(player_spell_mask,50,50,175,40,25,30)
    misc.ShakeScreen(60,3)
    PlaySound('power1',0.8)
    PlaySound('slash',0.8)
    New(tasker,function() --- Makes an async task that waits 90 seconds to raise the PoC back up
        task.Wait(90)
        self.collect_line=self.collect_line+300
    end)
    New(bullet_cleaner,self.x,self.y,500,10,65,true,false,0) --- Clears bullet in a circle
	New(himeka_bomb,self.x,self.y,3,0)
	New(himeka_bomb,self.x,self.y,-3,0)
	New(himeka_bomb,self.x,self.y,3,180)
	New(himeka_bomb,self.x,self.y,-3,180)
end
--[[
--- Special (for example, releases (key C)); this is commented out, but you can try uncommenting it and press C to drop some items
function himeka_player:special()
    _drop_item(item_power_large,1,player.x,player.y)
    _drop_item(item_bomb,1,player.x,player.y)
end
--]]
--- Rendering of the player code and options
function himeka_player:render()
    for i=1,4 do
        if self.sp[i] and self.sp[i][3]>0.5 then
            Render('himeka_support',self.supportx+self.sp[i][1],self.supporty+self.sp[i][2],self.timer*3) --- Rendering of the options
        end
    end
    player_class.render(self) --- Renders the player
end

------------------------------------------ Objects/Shots/Bombs/Effects
--- Main Shot

himeka_dark_shot=Class(object) --- The main shot, it is an object (object class)
function himeka_dark_shot:init(img,x,y,dmg) --- Initialization of the bullet (arguments: img (sprite), x (position), y (position), dmg (damage)
    self.x=x --- X position
    self.y=y --- Y position
    self.group=GROUP_PLAYER_BULLET --- Makes it part of the player bullet group
    self.layer=LAYER_PLAYER_BULLET --- Makes it part of the player bullet layer
    self.img=img --- It's image/sprite
    self.hscale=1.1 --- It's horizontal scale (1 is default)
    self.vscale=1.1 --- It's vertical scale (1 is default)
    self.a=50 --- It's X/horizontal hitbox
    self.b=20 --- It's Y/vertical hitbox
    self.rot=90 --- The orientation of the bullet/sprite (90 angle, aka Upwards (not related to speed))
    self.dmg=dmg --- The bullet's damage
    self.bound=false --- Makes it not despawn if off-screen
    self.killflag=false --- Makes it die once it collides with an enemy (setting off the "on kill()" function)
    self.vy=20 --- Makes the object go upwards
end

function himeka_dark_shot:frame() --- Action to make every frame
    if self.timer>5 then --- Turns self.bound to true (enables off screen deletion) after 5 frames of the object spawned
        self.bound=true --- Enables off screen deletion
    end
end

function himeka_dark_shot:kill() --- Action to make when it gets killed
    New(himeka_dark_shot_ef,'himeka_mainshot',self.x,self.y) --- Creates this bullet's kill effect
    Kill(self) --- Kills itself
end

--- Main Shot Effect (when killed)

himeka_dark_shot_ef=Class(object) --- The main shot's effect, it is an object (object class) --- f
function himeka_dark_shot_ef:init(img,x,y)
    self.x=x
    self.y=y
    self.img=img
    self.hscale=1.4
    self.vscale=1.4
    self.rot=ran:Int(85,95)
    self.vy=1
    SetImgState(self,'mul+add',255,255,100,100) --- Sets a blend mode to the object's image, and also colors it a bit redder
end

function himeka_dark_shot_ef:frame()
    if self.timer>19 then
    Kill(self)
    end
end

--- SubShot Blue

himeka_subshot_blue=Class(object) --- The blue subshot, it is an object (object class)
function himeka_subshot_blue:init(img,x,y,dmg,rot) --- Initialization of the bullet (arguments: img (sprite), x (position), y (position), dmg (damage)
    self.x=x
    self.y=y
    self.group=GROUP_PLAYER_BULLET
    self.layer=LAYER_PLAYER_BULLET
    self.img=img
    self.hscale=1.2
    self.vscale=1.2
    self.a=40
    self.b=10
    self.rot=rot
    self.dmg=dmg
    self.bound=false
    self.killflag=false
    SetV(self,13,rot,true)
    SetImgState(self,'',125,255,255,255)
end

function himeka_subshot_blue:frame()
    if self.timer>5 then
    self.bound=true
    end
end

function himeka_subshot_blue:kill()
    New(himeka_subshot_blue_ef,'himeka_greenpellet2',self.x,self.y,self.rot)
    Kill(self)
end

--- SubShot Blue Effect (when killed)

himeka_subshot_blue_ef=Class(object) --- The blue subshot's effect, it is an object (object class)
function himeka_subshot_blue_ef:init(img,x,y,rot)
    self.x=x
    self.y=y
    self.img=img
    self.hscale=1.4
    self.vscale=1.4
    self.rot=rot+ran:Int(85,95)
    SetV(self,3,rot,true)
	SetImgState(self,'mul+add',135,255,100,0)
end

function himeka_subshot_blue_ef:frame()
    if self.timer>19 then
        Kill(self)
    end
end


--- Bomb

himeka_bomb=Class(object)
function himeka_bomb:init(x,y,omiga,rot)
	self.x=x
    self.y=y
    self.img='himeka_bom'
	SetImgState(self,'mul+add',255,255,255,255)
    self.hscale=0.1
    self.vscale=0.1
	self.rot=rot
	self.dmg=1
	self.a=40
	self.b=40
	self.omiga=omiga
	self.group=GROUP_PLAYER_BULLET
    self.layer=LAYER_PLAYER_BULLET
	self.killflag=true
	task.New(self,function()
		misc.ShakeScreen(60,1)
		for i = 1, 180 do
			self.hscale, self.vscale = self.hscale + 0.005, self.vscale + 0.005
			self.a, self.b = self.a + 0.2, self.b + 0.2
			New(bullet_cleaner,self.x,self.y,self.a,1,5,true,false,0)
			task.Wait(1)
		end
		misc.ShakeScreen(200,3)
		for i = 1, 180 do
			self.hscale, self.vscale = self.hscale + 0.1, self.vscale + 0.1
			self.a, self.b = self.a + 5, self.b + 5
			New(bullet_cleaner,self.x,self.y,self.a,1,5,true,false,0)
			task.Wait(1)
		end
		do
			local _beg_a=255 local a=_beg_a  local _w_a=0 local _end_a=0 local _d_w_a=90/(15-1)
			for _=1,15 do
				SetImgState(self,'mul+add',a,255,255,255)
				task._Wait(1)
				_w_a=_w_a+_d_w_a a=(_end_a-_beg_a)*sin(_w_a)+(_beg_a)
			end
		end
		New(bullet_cleaner,self.x,self.y,self.a,1,5,true,false,0)
		Kill(self)
	end)
end

function himeka_bomb:frame()
	task.Do(self)
end




















